import 'package:flexidate/flexidate.dart';
import 'package:sunny_dart/sunny_dart.dart';

import '../smart_dates.dart';

mixin RelativeDateMixin {}
mixin SeekDirectionMixin {}
mixin SmartDateMixin implements ISmartDate {
  TimeSpan toTimeSpan() {
    final timeUnit = relativeDate?.timeUnit;
    final eventName = relativeDate?.eventName;
    final parsedTimeUnit = timeSpanUnitOf(timeUnit);
    final field = eventName != null
        ? TimeSpanUnit.year
        : parsedTimeUnit ?? TimeSpanUnit.year;
    return TimeSpan.ofSingleField(field, this.relativeDate?.amount ?? 1);
  }
}

mixin SmartDateResultsMixin implements ISmartDateResults {
  bool get isEmpty => results.isNullOrEmpty;
  bool get isNotEmpty => !results.isNullOrEmpty;
}

mixin ParseSmartDateRequestMixin {}
mixin SmartDateApiMixin {}
