library smart_dates;

import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_service_stubs/models/smart_dates/smart_dates.dart';

import 'model/parse_smart_date_request.dart';
import 'model/relative_date.dart';
import 'model/seek_direction.dart';
import 'model/smart_date.dart';
import 'model/smart_date_results.dart';

export 'package:sunny_service_stubs/models/smart_dates/smart_dates.dart';

export 'api/smart_date_api.dart';
export 'ext/ext.dart';
export 'model/parse_smart_date_request.dart';
export 'model/relative_date.dart';
export 'model/seek_direction.dart';
export 'model/smart_date.dart';
export 'model/smart_date_results.dart';

const smartDatesModuleRef = MModuleRef.ofParts("mverse", "smartDates", "0.0.1");

registerSmart_datesModels(
    MModelRegistry modelRegistry, MEnumRegistry enumRegistry) {
  modelRegistry.register(ParseSmartDateRequestRef,
      (json) => ParseSmartDateRequest(json as Map<String, dynamic>));
  IParseSmartDateRequest.of = ParseSmartDateRequest.of;
  IParseSmartDateRequest.fromJson = ParseSmartDateRequest.fromJson;

  modelRegistry.register(
      RelativeDateRef, (json) => RelativeDate(json as Map<String, dynamic>));
  IRelativeDate.of = RelativeDate.of;
  IRelativeDate.fromJson = RelativeDate.fromJson;

  SeekDirection.init();
  enumRegistry.register("mverse.smartDates.definitions.seekDirection",
      values: ISeekDirection.values,
      factory: (value) => SeekDirection.fromJson(value)!);
  modelRegistry.register(
      SmartDateRef, (json) => SmartDate(json as Map<String, dynamic>));
  ISmartDate.of = SmartDate.of;
  ISmartDate.fromJson = SmartDate.fromJson;

  modelRegistry.register(SmartDateResultsRef,
      (json) => SmartDateResults(json as Map<String, dynamic>));
  ISmartDateResults.of = SmartDateResults.of;
  ISmartDateResults.fromJson = SmartDateResults.fromJson;
}
